﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace CustomOutlookProperties
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("1430E0CF-CEB7-4F61-823D-02E59152A091"), ProgId("CustomOutlookProperties.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }
        private AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
        private AddinExpress.OL.ADXOlFormsCollectionItem adxOlFormsCollectionItem1;
        private ADXOutlookAppEvents adxOutlookEvents;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxOlFormsCollectionItem1 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxOlFormsManager1
            // 
            this.adxOlFormsManager1.Items.Add(this.adxOlFormsCollectionItem1);
            this.adxOlFormsManager1.SetOwner(this);
            // 
            // adxOlFormsCollectionItem1
            // 
            this.adxOlFormsCollectionItem1.AlwaysShowHeader = true;
            this.adxOlFormsCollectionItem1.FormClassName = "CustomOutlookProperties.frmCustomProperties";
            this.adxOlFormsCollectionItem1.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olMail;
            this.adxOlFormsCollectionItem1.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.RightSubpane;
            this.adxOlFormsCollectionItem1.UseOfficeThemeForBackground = true;
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.ItemSend += new AddinExpress.MSO.ADXOlItemSend_EventHandler(this.adxOutlookEvents_ItemSend);
            // 
            // AddinModule
            // 
            this.AddinName = "CustomOutlookProperties";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void adxOutlookEvents_ItemSend(object sender, ADXOlItemSendEventArgs e)
        {
            Outlook.MailItem mail = null;
            Outlook.Attachments attachments = null;
            Outlook.UserProperties props = null;

            try
            {
                if (e.Item is Outlook.MailItem)
                {
                    mail = e.Item as Outlook.MailItem;
                    props = mail.UserProperties;
                    attachments = mail.Attachments;
                    if (props.Count > 0)
                    {
                        string attachmentPath = PackageProperties(props);
                        attachments.Add(attachmentPath);
                    }
                }
            }
            finally
            {
                if (props != null) Marshal.ReleaseComObject(props);
                if (attachments != null) Marshal.ReleaseComObject(attachments);
            }
        }

        private string PackageProperties(Outlook.UserProperties props)
        {
            string savePath = string.Format("{0}\\OutlookProperties", Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData));
            var doc = new XmlDocument();
            var rootElement = (XmlElement)doc.AppendChild(doc.CreateElement("UserProperties"));
            Console.WriteLine(doc.OuterXml);
            for (int i = 1; i <= props.Count; i++)
            {
                var propElement = (XmlElement)rootElement.AppendChild(doc.CreateElement("UserProperty"));
                propElement.SetAttribute("Name", props[i].Name);
                propElement.InnerText = props[i].Value.ToString();
            }
            if (!Directory.Exists(savePath))
            {
                Directory.CreateDirectory(savePath);
            }

            string fullFilePath = savePath + "\\userproperties.xml";
            doc.Save(fullFilePath);
            return fullFilePath;
        }

    }
}

